| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::ImageCodec Class Referenceabstract
Core » Image

Codec specialized in images. More...

`#include <OgreImageCodec.h>`

Inheritance diagram for Ogre::ImageCodec:
[legend]

## Classes
class | ImageData
| Codec return class for images. More...

## Public Types
typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator< CodecList > | CodecIterator
typedef std::pair< MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata. More...

## Public Member Functions
virtual | ~ImageCodec ()
virtual DecodeResult | decode (const DataStreamPtr &input) const =0
| Codes the data from the input chunk into the output chunk. More...
virtual DataStreamPtr | encode (const MemoryDataStreamPtr &input, const CodecDataPtr &pData) const =0
| Codes the data in the input stream and saves the result in the output stream. More...
virtual void | encodeToFile (const MemoryDataStreamPtr &input, const String &outFileName, const CodecDataPtr &pData) const =0
| Codes the data in the input chunk and saves the result in the output filename provided. More...
String | getDataType () const
| Returns the type of the data that supported by this codec as a String. More...
virtual String | getType () const =0
| Returns the type of the codec as a String. More...
virtual bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec. More...
virtual String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const =0
| Maps a magic number header to a file extension, if this codec recognises it. More...

## Static Public Member Functions
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension. More...
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier. More...
static CodecIterator | getCodecIterator (void)
| Gets the iterator for the registered codecs. More...
static StringVector | getExtensions (void)
| Gets the file extension list for the registered codecs. More...
static bool | isCodecRegistered (const String &codecType)
| Return whether a codec is registered already. More...
static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database. More...
static void | unregisterCodec (Codec *pCodec)
| Unregisters a codec from the database. More...

## Detailed Description

Codec specialized in images.

Remarks
  The users implementing subclasses of ImageCodec are required to return a valid pointer to a ImageData class from the decode(...) function.

## Member Typedef Documentation

## ◆ CodecDataPtr

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr
| inherited

## ◆ CodecIterator

typedef ConstMapIterator<CodecList> Ogre::Codec::CodecIterator
| inherited

## ◆ DecodeResult

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult
| inherited

Result of a decoding; both a decoded data stream and CodecData metadata.

## Constructor & Destructor Documentation

## ◆ ~ImageCodec()

virtual Ogre::ImageCodec::~ImageCodec | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getDataType()

String Ogre::ImageCodec::getDataType | ( |  | ) | const
| inline virtual

Returns the type of the data that supported by this codec as a String.

Implements Ogre::Codec.

## ◆ registerCodec()

static void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) |
| inline static inherited

Registers a new codec in the database.

References Ogre::Exception::ERR_DUPLICATE_ITEM, Ogre::Codec::getType(), and OGRE_EXCEPT.

## ◆ isCodecRegistered()

static bool Ogre::Codec::isCodecRegistered | ( | const String & | codecType | ) |
| inline static inherited

Return whether a codec is registered already.

## ◆ unregisterCodec()

static void Ogre::Codec::unregisterCodec | ( | Codec * | pCodec | ) |
| inline static inherited

Unregisters a codec from the database.

References Ogre::Codec::getType().

## ◆ getCodecIterator()

static CodecIterator Ogre::Codec::getCodecIterator | ( | void |  | ) |
| inline static inherited

Gets the iterator for the registered codecs.

## ◆ getExtensions()

static StringVector Ogre::Codec::getExtensions | ( | void |  | ) |
| static inherited

Gets the file extension list for the registered codecs.

## ◆ getCodec() [1/2]

static Codec* Ogre::Codec::getCodec | ( | const String & | extension | ) |
| static inherited

Gets the codec registered for the passed in file extension.

## ◆ getCodec() [2/2]

static Codec* Ogre::Codec::getCodec | ( | char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  |
| static inherited

Gets the codec that can handle the given 'magic' identifier.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

## ◆ encode()

virtual DataStreamPtr Ogre::Codec::encode | ( | const MemoryDataStreamPtr & | input,
|  | const CodecDataPtr & | pData
| ) |  | const
| pure virtual inherited

Codes the data in the input stream and saves the result in the output stream.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ETCCodec, Ogre::ASTCCodec, Ogre::PVRTCCodec, Ogre::STBIImageCodec, and Ogre::EXRCodec.

## ◆ encodeToFile()

virtual void Ogre::Codec::encodeToFile | ( | const MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | const CodecDataPtr & | pData
| ) |  | const
| pure virtual inherited

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters

  input | The input data
  outFileName | The filename to write to
  pData | Extra information to be passed to the codec (codec type specific)

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ETCCodec, Ogre::ASTCCodec, Ogre::PVRTCCodec, Ogre::STBIImageCodec, and Ogre::EXRCodec.

## ◆ decode()

virtual DecodeResult Ogre::Codec::decode | ( | const DataStreamPtr & | input | ) | const
| pure virtual inherited

Codes the data from the input chunk into the output chunk.

Parameters

  input | Stream containing the encoded data

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ETCCodec, Ogre::ASTCCodec, Ogre::PVRTCCodec, Ogre::STBIImageCodec, and Ogre::EXRCodec.

## ◆ getType()

virtual String Ogre::Codec::getType | ( |  | ) | const
| pure virtual inherited

Returns the type of the codec as a String.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ETCCodec, Ogre::ASTCCodec, Ogre::PVRTCCodec, Ogre::STBIImageCodec, and Ogre::EXRCodec.

Referenced by Ogre::Codec::registerCodec(), and Ogre::Codec::unregisterCodec().

## ◆ magicNumberMatch()

virtual bool Ogre::Codec::magicNumberMatch | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | const
| inline virtual inherited

Returns whether a magic number header matches this codec.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

## ◆ magicNumberToFileExt()

virtual String Ogre::Codec::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) |  | const
| pure virtual inherited

Maps a magic number header to a file extension, if this codec recognises it.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns
  A blank string if the magic number was unknown, or a file extension.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, Ogre::ETCCodec, Ogre::ASTCCodec, Ogre::PVRTCCodec, Ogre::STBIImageCodec, and Ogre::EXRCodec.

The documentation for this class was generated from the following file:

- OgreImageCodec.h